<?php
$DEBUG = 0;

/***************************************************************************
phpTrafficA @soft.ZoneO.net
Copyright (C) 2004-2008 ZoneO-soft, Butchu (email: "butchu" with the domain "zoneo.net")

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

More Info About The Licence At http://www.gnu.org/copyleft/gpl.html
****************************************************************************/

function echoReferer($c,$table, $site,$sid,$sort,$order,$start,$pageid="all") {
global $DEBUG;
global $strings;
global $lang;
global $display;
global $sites;

$isLoggedIn = isloggedin ($c);
$nperpage = $display['ntoplong'];

// Restriction on page for keyword search
if ($pageid=="all") {
	$where = "";
	$ncol = 6;
} else {
	$where = " WHERE page=$pageid ";
	$ncol = 5;
}
if ($isLoggedIn) $ncol += 1; // One more to be able to ban referrers

//
if ($sort == "") {
	$sort = "hits";
	$order = "asc";
}
if ($start == "") $start = 1;

// Title
if ($pageid=='all') {
	$title = $strings['forthewholesite'];
} else {
	$pagename = pagename($c,$table,$pageid);
	$title = $strings['for']." $pagename";
}

// Page navigation
echo formnavpages($c,$table,$pageid,"index.php?mode=stats&amp;sid=$sid&amp;show=ref&amp;sort=hits&amp;start=1&amp;lang=$lang",$strings['Statisticsfor'], true);

// If referrer search, there is a second restriction
if (isset($_GET['searchref'])) {
	$searchref = $_GET['searchref'];
	if ($pageid == 'all') {
		$where = "WHERE address LIKE '%$searchref%'";
	} else {
		$where = " WHERE page=$pageid AND address LIKE '%$searchref%'";
	}
	$searchURL = "&amp;searchref=$searchref";
	$title .= ": ".$strings['searchresultsfor']." '$searchref'";
} else {
	$searchURL = "";
	$searchref = "";
}

// Sorting things
if ($sort == "hits") {
	$sortstring = "ORDER BY count";
} else if ($sort == "added") {
	$sortstring = "ORDER BY first";
} else if ($sort == "latest") {
	$sortstring = "ORDER BY last";
} else if ($sort == "refs") {
	$sortstring = "ORDER BY address";
}
if ($order=="desc") {
	$sortstring .= " ASC";
} else {
	$sortstring .= " DESC";
}
$f = $nperpage * ($start - 1);
$limits =  "LIMIT $f,$nperpage";
$sql = "SELECT id,first,last,page,address,count FROM ${table}_referrer $where $sortstring $limits";

// Arrows for sorting choice
$arrowsLatest = linksUpDown("./index.php?mode=stats&amp;sid=$sid&amp;show=ref&amp;sort=latest&amp;start=1&amp;pageid=$pageid&amp;lang=$lang$searchURL", $strings['Sortby']." ".$strings['Latesthit'], '');
$arrowsFirst = linksUpDown("./index.php?mode=stats&amp;sid=$sid&amp;show=ref&amp;sort=added&amp;start=1&amp;pageid=$pageid&amp;lang=$lang$searchURL", $strings['Sortby']." ".$strings['Latests'], '');
$arrowsHits = linksUpDown("./index.php?mode=stats&amp;sid=$sid&amp;show=ref&amp;sort=hits&amp;start=1&amp;pageid=$pageid&amp;lang=$lang$searchURL", $strings['Sortby']." ".$strings['Numberofhits'], '');
$arrowsRefs = linksUpDown("./index.php?mode=stats&amp;sid=$sid&amp;show=ref&amp;sort=refs&amp;start=1&amp;pageid=$pageid&amp;lang=$lang$searchURL", $strings['Sortby']." ".$strings['Numberofhits'], '');

// Start for Numbering
$index = $nperpage * ($start - 1);

// Table with referrers list
echo "\n<table class=\"stat\">
<tr class=\"title\"><td colspan=\"$ncol\">".$strings['Topreferrers']." $title</td></tr>";
echo "<tr class=\"caption\"><td>&nbsp;</td>";
if ($pageid=="all") echo "<td>".$strings['Page']."</td>";
if ($isLoggedIn) { $colRef = 2; } else { $colRef = 1;}
echo "<td>".$strings['Firsttime']."</td><td>".$strings['Latesthit']."</td><td colspan=\"$colRef\">".$strings['Referrer']."</td><td>".$strings['Hits']."</td></tr>\n";
echo "<tr class=\"caption\"><td>&nbsp;</td>";
if ($pageid=="all") echo "<td>&nbsp;</td>";
echo "<td>$arrowsFirst</td><td>$arrowsLatest</td><td colspan=\"$colRef\">$arrowsRefs</td><td>$arrowsHits</td></tr>\n";

$res = mysql_query($sql,$c);
$n = 0;
$timeserver = time() + 3600*$sites[$sid]['timediff'];
$today = strtotime(date("M j, Y", $timeserver));
while ($row = mysql_fetch_object($res)) {
	$index += 1;
	$n += 1;
	$refid = $row->id;
	$ref = $row->address;
	$count = $row->count;
	$thispageid = $row->page;
	$date = strtotime($row->first);
	if ($date>$today) {
		$first = timetoday($date,0);
	} else {
		$first = dayMmYear($date,0);
	}
	$date = strtotime($row->last);
	if ($date>$today) {
		$last = timetoday($date,0);
	} else {
		$last = dayMmYear($date,0);
	}
	if ($pageid=="all") {
		$linkpage = linksforpage ($sid, shortenPage(pagename($c,$table,$thispageid),1), $thispageid);
	}
	$refText = urlLink($ref,3,"class=\"basic\"");
	if ($count == 1) $refText .= " <font color=\"#FF0000\">-- ".$strings['new!']."</font>";
	if ($isLoggedIn) {
		$banText = "<td><a href=\"javascript:banRef($sid, $refid)\">".$strings['ban']."</a></td>";
	} else {
		$banText = "";
	}
	if (($n % 2) == 0) { $even = "even";} else {$even="odd";}
	echo "\n<tr class=\"data av $even\"><td>".format_float($index,0)."</td>";
	if ($pageid=="all") echo "<td>$linkpage</td>";
	echo "<td>$first</td><td>$last</td><td>$refText</td>$banText<td>".hits($count)."</td></tr>\n";
}
if ($n == 0) {
	echo "\n<tr><td colspan=\"$ncol\"><div align=\"center\">".$strings['Nothingyet']."</div></td></tr>\n";
} else {
	$req = "SELECT COUNT(*) as count FROM ${table}_referrer $where;";
	$res = mysql_query($req,$c);
	$row = mysql_fetch_object($res);
	$nref = $row->count;
	$npages = intval($nref/$nperpage)+1;
	echo "<tr><td colspan=\"$ncol\"><div align=\"center\"><strong>".$strings['Page'].":</strong> ";
	echo navPage("./index.php?mode=stats&amp;sid=$sid&amp;show=ref&amp;sort=$sort&amp;order=$order&amp;pageid=$pageid&amp;lang=$lang$searchURL&amp;start=", $npages, $start);
	echo "</div></td></tr>\n";
}
echo "</table>\n";

// Search tables
echo "<form method='get' action='index.php'>
<input type='hidden' name='mode' value='stats'>
<input type='hidden' name='sid' value='$sid'>
<input type='hidden' name='show' value='ref'>
<input type='hidden' name='sort' value='hits'>
<input type='hidden' name='start' value='1'>
<input type='hidden' name='pageid' value='$pageid'>
<input type='hidden' name='lang' value='$lang'>
<table class=\"stat\">
<tr class=\"top\"><td>".$strings['Referrersearch']."</td>
<td align=\"center\"><input type='text' name='searchref' value='$searchref' size='40'></td>
<td><input type='submit' value='Search'></td></tr>
</table></form>";
}

?>